ufw-tools/sup

133 lines
2.6 KiB
Plaintext
Raw Normal View History

2014-10-04 08:19:37 +00:00
#!/usr/bin/env bash
2014-10-04 08:33:23 +00:00
# Copyright (c) 2012 fbt <fbt@fleshless.org>
#
# About:
# A simple upload script for ZFH (http://zerofiles.org)
2014-10-04 08:19:37 +00:00
cfg_url_regex='^[A-Za-z]([A-Za-z0-9+.-]+)?://.+'
cfg_tmp_dir="/tmp/$USER/sup"; TEMPDIR="$cfg_tmp_dir"
cfg_script_url='https://zfh.so/upload'
cfg_screenshot_ext='png'
[[ -f $HOME/.suprc ]] && { source $HOME/.suprc; }
sup.msg() { echo "[sup] $1"; }
sup.err() { sup.msg "(error) $1" >&2; }
sup.usage() {
echo "Usage: `basename $0` [-RsF] [-D num] [file/url]"
}
sup.env() {
for i in "$cfg_tmp_dir"; do
[[ -d "$i" ]] || { mkdir -p "$i"; }
done
}
sup.upload() {
curl -F file="@$file" \
-F upload_mode='api' \
-F flag_private="$flag_private" \
-F secret="$secret" \
-F submit="" \
"$cfg_script_url" -sL -A 'zerofiles.org upload script' || { return 1; }
[[ "$flag_rm" ]] && { rm "$file"; }
return 0
}
sup.mktemp() {
>"$1" || {
sup.err "Cannot create $1!"
return 1
}
echo "$1"
}
sup.scrot() {
local tmp_file_name
[[ "$scrot_exec" ]] || { scrot_exec=`which scrot`; }
[[ "$scrot_exec" ]] || {
sup.err "Please install scrot to use this function"
return 1
}
[[ "$flag_scrot_fullscreen" ]] || { scrot_args+=( '-s' ); }
[[ "$cfg_scrot_delay" ]] && { scrot_args+=( "-d $cfg_scrot_delay" ); }
2014-10-04 08:45:31 +00:00
tmp_file_name="$(sup.mktemp "${cfg_tmp_dir}" "${cfg_screenshot_ext}")"
2014-10-04 08:19:37 +00:00
scrot "${scrot_args[@]}" "${cfg_tmp_dir}/$tmp_file_name" || {
sup.err "Failed to take a screenshot."
return 1
}
echo "${cfg_tmp_dir}/$tmp_file_name"
}
sup.exclude() {
[[ "$2" ]] && { echo "$1"; return 1; }
return 0
}
sup.if_url() { echo "$1" | grep -oE "$cfg_url_regex" &>/dev/null; }
2014-10-04 08:45:31 +00:00
sup.mktemp() {
local tmp_file_name tmp_file_name_extra="$2" tmp_dir="$1"
[[ -d "$tmp_dir" ]] || {
sup.err "${tmp_dir} does not exist or is not a directory."
return 1
}
until [[ ! -e "${tmp_dir}/${tmp_file_name}" ]]; do
tmp_file_name="${RANDOM}${RANDOM}${tmp_file_name_extra}"
done
echo "${tmp_dir}/${tmp_file_name}"
}
2014-10-04 08:19:37 +00:00
main() {
while [[ "$1" ]]; do
case "$1" in
-p|--private) flag_private='true';;
-R|--remove-file) flag_rm='1';;
-s|--screenshot) flag_scrot='1';;
-F|--fullscreen) flag_scrot_fullscreen='1';;
-D|--screenshot-delay) cfg_scrot_delay="$2"; shift;;
2014-10-04 08:33:23 +00:00
2014-10-04 08:19:37 +00:00
-h|--help|--usage) sup.usage; return;;
--) break;;
*) args+=( "$1" );;
esac
shift
done
sup.env
if [[ "$flag_scrot" ]]; then
file="$(sup.scrot)" || { return 1; }
else
target="${args[0]}"; [[ "$target" ]] || { sup.usage; exit 1; }
sup.if_url "$target" && {
2014-10-04 08:45:31 +00:00
file=`sup.mktemp "$cfg_tmp_dir"`
2014-10-04 08:19:37 +00:00
curl -s "$target" > "$file" || {
sup.err "Could not download file."
return 1
}
}
fi
sup.upload
}
main "$@"